function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var button = require('primereact/button');
var reactGridLayout = require('react-grid-layout');
var _ = _interopDefault(require('lodash'));
var ReactApexChart = _interopDefault(require('react-apexcharts'));
var axios = _interopDefault(require('axios'));
var overlaypanel = require('primereact/overlaypanel');
var dropdown = require('primereact/dropdown');
var ripple = require('primereact/ripple');

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

var ColumnChartComponent = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(ColumnChartComponent, _React$Component);

  function ColumnChartComponent(props) {
    return _React$Component.call(this, props) || this;
  }

  var _proto = ColumnChartComponent.prototype;

  _proto.render = function render() {
    return React__default.createElement("div", {
      id: "chart"
    });
  };

  return ColumnChartComponent;
}(React__default.Component);

var PieChartComponent = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(PieChartComponent, _React$Component);

  function PieChartComponent(props) {
    return _React$Component.call(this, props) || this;
  }

  var _proto = PieChartComponent.prototype;

  _proto.render = function render() {
    return React__default.createElement("div", null);
  };

  return PieChartComponent;
}(React__default.Component);

var MixedChartComponent = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(MixedChartComponent, _React$Component);

  function MixedChartComponent(props) {
    return _React$Component.call(this, props) || this;
  }

  var _proto = MixedChartComponent.prototype;

  _proto.render = function render() {
    return React__default.createElement("div", {
      id: "chart"
    });
  };

  return MixedChartComponent;
}(React__default.Component);

var AreaChartComponent = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(AreaChartComponent, _React$Component);

  function AreaChartComponent(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.state = {
      series: [{
        name: 'series1',
        data: [31, 40, 28, 51, 42, 109, 100]
      }, {
        name: 'series2',
        data: [11, 32, 45, 32, 34, 52, 41]
      }],
      options: {
        chart: {
          height: 350,
          type: 'area'
        },
        colors: ['#22D792', '#2C99F7', '#FBC445', '#F74E49', '#717585'],
        dataLabels: {
          enabled: false
        },
        stroke: {
          curve: 'smooth'
        },
        xaxis: {
          type: 'datetime',
          categories: ['2018-09-19T00:00:00.000Z', '2018-09-19T01:30:00.000Z', '2018-09-19T02:30:00.000Z', '2018-09-19T03:30:00.000Z', '2018-09-19T04:30:00.000Z', '2018-09-19T05:30:00.000Z', '2018-09-19T06:30:00.000Z']
        },
        tooltip: {
          x: {
            format: 'dd/MM/yy HH:mm'
          }
        }
      }
    };
    return _this;
  }

  var _proto = AreaChartComponent.prototype;

  _proto.render = function render() {
    return React__default.createElement("div", {
      id: "chart"
    }, this.props.dateFilter && React__default.createElement("div", {
      className: "filter-label"
    }, "  Date: ", this.props.dateFilter.toLocaleDateString("en-US") + ''), React__default.createElement(ReactApexChart, {
      options: this.state.options,
      series: this.state.series,
      type: "area",
      height: '100%'
    }));
  };

  return AreaChartComponent;
}(React__default.Component);

var TimelineChartComponent = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(TimelineChartComponent, _React$Component);

  function TimelineChartComponent(props) {
    return _React$Component.call(this, props) || this;
  }

  var _proto = TimelineChartComponent.prototype;

  _proto.render = function render() {
    return React__default.createElement("div", {
      id: "chart"
    });
  };

  return TimelineChartComponent;
}(React__default.Component);

var CandleChartComponent = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(CandleChartComponent, _React$Component);

  function CandleChartComponent(props) {
    return _React$Component.call(this, props) || this;
  }

  var _proto = CandleChartComponent.prototype;

  _proto.render = function render() {
    return React__default.createElement("div", {
      id: "chart"
    });
  };

  return CandleChartComponent;
}(React__default.Component);

var ApiQueryFilters = /*#__PURE__*/function () {
  function ApiQueryFilters() {
    this.PageIndex = null;
    this.PageSize = null;
    this.SortBy = null;
    this.SortDirection = null;
    this.GetCount = null;
    this.Tenant = null;
    this.AdditionalFilters = [];
    this.ForceCacheRefresh = false;
    this.DontApplyVirtualization = false;
    this.queryId = '';
    this.queryCode = '';
    this.userid = '';
    this.ObjectTableName = '';
    this.Filter1Name = null;
    this.Filter1Operator = null;
    this.GetAll = true;
  }

  var _proto = ApiQueryFilters.prototype;

  _proto.addAdditionalFilter = function addAdditionalFilter(FieldName, FieldValue, FieldValue2, FieldValue3, Operator, IsCustom, DisplayInList, IsCustomField, FieldDataType, IgnoreFilter, IsCacheOnClient, ForceEnableAdd) {
    if (IgnoreFilter === void 0) {
      IgnoreFilter = false;
    }

    if (IsCacheOnClient === void 0) {
      IsCacheOnClient = false;
    }

    if (ForceEnableAdd === void 0) {
      ForceEnableAdd = false;
    }

    var params = new ApiQueryFiltersAddParams();
    params.FieldName = FieldName;
    params.FieldValue = FieldValue;
    params.FieldValue2 = FieldValue2;
    params.FieldValue3 = FieldValue3;
    params.Operator = Operator;
    params.IsCustom = IsCustom;
    params.DisplayInList = DisplayInList;
    params.IsCustomField = IsCustomField;
    params.FieldDataType = FieldDataType;
    params.IgnoreFilter = IgnoreFilter;
    params.IsCacheOnClient = IsCacheOnClient;
    params.ForceEnableAdd = ForceEnableAdd;
    this.pushAdditionalFilter(params);
  };

  _proto.myReplace = function myReplace(myString) {
    var myNewString = "";

    for (var i = 0; i < myString.length; i++) {
      if (myString[i] == '"') {
        myNewString = myNewString + '\\"';
      } else {
        myNewString = myNewString + myString[i];
      }
    }

    return myNewString;
  };

  _proto.removeAdditionalFilter = function removeAdditionalFilter(FieldName) {
    var item = this.AdditionalFilters.filter(function (d) {
      return d.FieldName == FieldName && d.IsLookUpfilter == true;
    })[0];

    if (item) {
      var index = this.AdditionalFilters.indexOf(item);
      this.AdditionalFilters.splice(index, 1);
    }
  };

  _proto.pushAdditionalFilter = function pushAdditionalFilter(params) {
    if (!params.IsCacheOnClient) {
      if (typeof params.FieldValue === "string") {
        if (params.FieldValue) params.FieldValue = this.myReplace(params.FieldValue);
        if (params.FieldName != "ImportersFilter") params.FieldValue = encodeURIComponent(params.FieldValue);
      }

      if (typeof params.FieldValue2 === "string") {
        if (params.FieldValue) params.FieldValue2 = this.myReplace(params.FieldValue2);
        params.FieldValue2 = encodeURIComponent(params.FieldValue2);
      }

      if (typeof params.FieldValue3 === "string") {
        if (params.FieldValue) params.FieldValue3 = this.myReplace(params.FieldValue3);
        params.FieldValue3 = encodeURIComponent(params.FieldValue3);
      }
    }

    var existedItem = this.AdditionalFilters.find(function (d) {
      return d.FieldName == params.FieldName;
    });

    if (!existedItem || params.ForceEnableAdd) {
      var item = new FilterItem(params.FieldName, params.FieldValue, params.FieldValue2, params.FieldValue3, params.Operator, params.IsCustom, params.DisplayInList, params.IsCustomField, params.FieldDataType, params.IgnoreFilter, params.IsCacheOnClient, params.IsLookUpFilter);
      this.AdditionalFilters.push(item);
    }
  };

  return ApiQueryFilters;
}();
var FilterItem = function FilterItem(FieldName, FieldValue, FieldValue2, FieldValue3, Operator, IsCustom, DisplayInList, IsCustomField, FieldDataType, IgnoreFilter, IsCacheOnClient, IsLookUpfilter) {
  if (IsCacheOnClient === void 0) {
    IsCacheOnClient = false;
  }

  if (IsLookUpfilter === void 0) {
    IsLookUpfilter = false;
  }

  this.FieldName = FieldName;
  this.FieldValue = FieldValue;
  this.FieldValue2 = FieldValue2;
  this.FieldValue3 = FieldValue3;
  this.Operator = Operator;
  this.IsCustom = IsCustom;
  this.DisplayInList = DisplayInList;
  this.IsCustomField = IsCustomField;
  this.FieldDataType = FieldDataType;
  this.IgnoreFilter = IgnoreFilter;
  this.IsCacheOnClient = IsCacheOnClient;
  this.IsLookUpfilter = IsLookUpfilter;
};
var ApiQueryFiltersAddParams = function ApiQueryFiltersAddParams() {
  this.FieldName = '';
  this.Operator = '';
  this.IsCustom = false;
  this.DisplayInList = false;
  this.IsCustomField = false;
  this.FieldDataType = '';
  this.IgnoreFilter = false;
  this.IsCacheOnClient = false;
  this.ForceEnableAdd = false;
  this.IsLookUpFilter = false;
};

var Tools = /*#__PURE__*/function () {
  function Tools() {}

  Tools.GetLogitudeURL = function GetLogitudeURL() {
    var logitude_url = location.href.replace('index.html', '');

    if (location.href.indexOf('localhost') > -1) {
      logitude_url = 'http://localhost:9996';
    } else {
      var urlArr = location.href.split("/index.html");
      var url = urlArr[0];
      url = url.replace(url.substring(url.lastIndexOf('/'), url.length), "");
      logitude_url = url;
    }

    return logitude_url;
  };

  return Tools;
}();

var DataService = /*#__PURE__*/function () {
  function DataService() {
    this._apiUrl = Tools.GetLogitudeURL();
  }

  var _proto = DataService.prototype;

  _proto.getObjectTables = function getObjectTables(filters) {
    var token = this.getTokenFromStorage();
    var apiURL = this._apiUrl + "/api/ObjectTableViews/getbyfilters?";
    apiURL = this.ConcatFiltersToURL(filters, apiURL);
    return axios.get(apiURL, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.getObjectFields = function getObjectFields(filters) {
    var token = this.getTokenFromStorage();
    var apiURL = this._apiUrl + "/api/ObjectFieldViews/getbyfilters?";
    apiURL = this.ConcatFiltersToURL(filters, apiURL);
    return axios.get(apiURL, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.getDataByFilters = function getDataByFilters(filters, tableName) {
    var token = this.getTokenFromStorage();
    var apiURL = this._apiUrl + "/api/" + tableName + "Views/getbyfilters?";
    apiURL = this.ConcatFiltersToURL(filters, apiURL);
    return axios.get(apiURL, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.ConcatFiltersToURL = function ConcatFiltersToURL(filters, urlparameters) {
    var mykeys = Object.keys(filters);
    var addtionalFiltersValues = null;

    for (var i in mykeys) {
      var propName = mykeys[i];
      var propValue = filters[propName];
      var ignoreFilter = propName.indexOf("Operator") > 0 && propValue == "Equals" || propName == "AdditionalFilters";

      if (urlparameters != "?") {
        urlparameters = urlparameters.concat('&');
      }

      if (!ignoreFilter) {
        propValue = propValue ? encodeURIComponent(propValue) : '';
        urlparameters = urlparameters.concat(propName.concat('=').concat(propValue));
      }

      if (propName == "AdditionalFilters" && propValue.length > 0) {
        addtionalFiltersValues = JSON.stringify(propValue);
      }
    }

    if (addtionalFiltersValues) {
      urlparameters = urlparameters.concat("&AdditionalFilters=").concat(addtionalFiltersValues);
    }

    return urlparameters;
  };

  _proto.getTokenFromStorage = function getTokenFromStorage() {
    return window.localStorage.getItem("token") || '';
  };

  return DataService;
}();

var BarChartComponent = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(BarChartComponent, _React$Component);

  function BarChartComponent(props) {
    var _this$props$widget;

    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.data = [];
    var filters = new ApiQueryFilters();
    var dataService = new DataService();
    if ((_this$props$widget = _this.props.widget) !== null && _this$props$widget !== void 0 && _this$props$widget.Title) dataService.getDataByFilters(filters, _this.props.widget.Title || '').then(function (response) {
      console.log("dataService.getDataByFilters", response);
      _this.data = response.data.Result;

      _this.InitChart();
    });
    _this.state = {
      series: [{
        data: []
      }],
      options: {
        chart: {
          type: "bar",
          height: 350,
          events: {
            dataPointSelection: function dataPointSelection(event, chartContext, config) {
              var data = config.w.config.xaxis.categories[config.seriesIndex];
              console.log("Selected " + data);
            }
          }
        },
        colors: ["#22D792", "#2C99F7", "#FBC445", "#F74E49", "#717585"],
        plotOptions: {
          bar: {
            borderRadius: 4,
            horizontal: true
          }
        },
        dataLabels: {
          enabled: false
        },
        xaxis: {
          categories: []
        }
      }
    };
    return _this;
  }

  var _proto = BarChartComponent.prototype;

  _proto.InitChart = function InitChart() {
    var groups = this.GroupItems();
    var catItems = Object.keys(groups);
    var dataItems = Object.values(groups);
    this.setState({
      series: [{
        data: dataItems
      }],
      options: {
        chart: {
          type: "bar",
          height: 350,
          events: {
            dataPointSelection: function dataPointSelection(event, chartContext, config) {
              var data = config.w.config.xaxis.categories[config.seriesIndex];
              console.log("Selected " + data);
            }
          }
        },
        colors: ["#22D792", "#2C99F7", "#FBC445", "#F74E49", "#717585"],
        plotOptions: {
          bar: {
            borderRadius: 4,
            horizontal: true
          }
        },
        dataLabels: {
          enabled: false
        },
        xaxis: {
          categories: catItems
        }
      }
    });
  };

  _proto.GroupItems = function GroupItems() {
    var _this2 = this;

    var groups = this.data.reduce(function (groups, record) {
      var CreateGroup = function CreateGroup(groups, record) {
        var group = groups[record] || [];
        group.push(record);
      };

      var SetGroupData = function SetGroupData() {
        var groupByFieldName = _this2.props.widget.GroupBy + "";
        var currentGroupValue = groups[record[groupByFieldName]];
        groups[record[groupByFieldName]] = currentGroupValue;
      };

      CreateGroup(groups, record);
      SetGroupData();
      return groups;
    }, {});
    return groups;
  };

  _proto.render = function render() {
    return React__default.createElement("div", {
      id: "chart"
    }, React__default.createElement("div", null, this.props.dateFilter && React__default.createElement("div", {
      className: "filter-label"
    }, "  Date: ", this.props.dateFilter.toLocaleDateString("en-US") + '')), React__default.createElement(ReactApexChart, {
      options: this.state.options,
      series: this.state.series,
      type: "bar",
      height: "100%"
    }));
  };

  return BarChartComponent;
}(React__default.Component);

var WidgetCard = function WidgetCard(props, state) {
  var _props$widget, _widgetComponents$fin;

  var moreBtnToggle = React.useRef(null);
  var widgetComponents = [{
    type: "Bar",
    component: BarChartComponent
  }, {
    type: "Column",
    component: ColumnChartComponent
  }, {
    type: "Pie",
    component: PieChartComponent
  }, {
    type: "Mixed",
    component: MixedChartComponent
  }, {
    type: "Timeline",
    component: TimelineChartComponent
  }, {
    type: "Candle",
    component: CandleChartComponent
  }, {
    type: "Area",
    component: AreaChartComponent
  }];
  return React__default.createElement("div", {
    className: "panel",
    key: props.el.i
  }, React__default.createElement("header", null, React__default.createElement("h1", null, ((_props$widget = props.widget) === null || _props$widget === void 0 ? void 0 : _props$widget.WidgetName) || "not set"), React__default.createElement(button.Button, {
    icon: "pi pi-ellipsis-v",
    className: "p-button-lg p-button-rounded p-button-text",
    onClick: function onClick(e) {
      var _moreBtnToggle$curren;

      return (_moreBtnToggle$curren = moreBtnToggle.current) === null || _moreBtnToggle$curren === void 0 ? void 0 : _moreBtnToggle$curren.toggle(e);
    }
  }), React__default.createElement(overlaypanel.OverlayPanel, {
    ref: moreBtnToggle,
    className: "buttons-overlay"
  }, React__default.createElement("div", {
    className: "buttons-list"
  }, React__default.createElement("div", {
    onClick: function onClick() {
      return props.editBtnClicked(props.widget);
    }
  }, " Edit "), React__default.createElement("div", {
    onClick: function onClick() {
      return props.deleteBtnClicked(props.el.i);
    }
  }, "Remove")))), React__default.createElement("div", {
    className: "dashboard-widget"
  }, React__default.createElement((_widgetComponents$fin = widgetComponents.find(function (wc) {
    return wc.type === props.widget.WidgetType;
  })) === null || _widgetComponents$fin === void 0 ? void 0 : _widgetComponents$fin.component, {
    key: props.el.i,
    dateFilter: props.dateFilter,
    widget: props.widget
  })));
};

var ResponsiveReactGridLayout = reactGridLayout.WidthProvider(reactGridLayout.Responsive);

var DashboardDesigner = function DashboardDesigner(props) {
  var _useState = React.useState(React.createRef());

  var _useState2 = React.useState(React.createRef());

  var _useState3 = React.useState([{
    type: "Bar",
    component: BarChartComponent
  }, {
    type: "Col",
    component: ColumnChartComponent
  }, {
    type: "Pie",
    component: PieChartComponent
  }, {
    type: "Are",
    component: AreaChartComponent
  }]);

  var array12 = Array.from({
    length: 12
  }).fill(null);
  var savedLayouts = getFromStorage("grid-layout");
  var savedWidgets = getFromStorage("grid-widgets");
  var minimumPlaceholderRowsCount = 12;

  var _useState4 = React.useState(savedLayouts || {
    lg: []
  }),
      layouts = _useState4[0],
      setLayouts = _useState4[1];

  var _useState5 = React.useState(Array.from({
    length: minimumPlaceholderRowsCount
  }).fill(null)),
      placeholderRowsArray = _useState5[0],
      setplaceholderRowsArray = _useState5[1];

  var _useState6 = React.useState(false),
      setShowMsg = _useState6[1];

  var _useState7 = React.useState(undefined),
      dateFilter = _useState7[0];

  var _useState8 = React.useState(false);

  var _useState9 = React.useState("");

  var _useState10 = React.useState(savedWidgets || []),
      widgets = _useState10[0],
      setWidgets = _useState10[1];

  var _useState11 = React.useState(minimumPlaceholderRowsCount),
      setPlaceholderRows = _useState11[1];

  function _onLayoutChange(layout, layouts) {
    console.log(layout, layouts);
    saveToStorage("grid-layout", layouts);
    saveToStorage("grid-widgets", widgets);
    setLayouts(layouts);
    UpdatePlaceholderDimensions();
  }

  function deletePanel(i) {
    var layout = layouts["lg"];
    var itemIndex = layout.findIndex(function (d) {
      return d.i === i;
    });
    layout.splice(itemIndex, 1);
    setLayouts({
      lg: [].concat(layout)
    });
    setWidgets(_.reject(widgets, {
      i: i
    }));
    SaveGrid();
  }

  function SaveGrid() {
    saveToStorage("grid-layout", layouts);
    saveToStorage("grid-widgets", widgets);
  }

  function editWidget(widget) {
    props.openEditWidget(widget);
  }

  function FindWidget(el) {
    return widgets.find(function (d) {
      return d.i === el.i;
    });
  }

  function saveToStorage(key, value) {
    setShowMsg(true);
    setTimeout(function () {
      setShowMsg(false);
    }, 2000);
    window.localStorage.setItem(key, JSON.stringify(value));
  }

  function getFromStorage(key) {
    var layout = window.localStorage.getItem(key);
    return JSON.parse(layout);
  }

  function UpdatePlaceholderDimensions() {
    var _gridLayout$;

    var gridLayout = document.getElementsByClassName('react-grid-layout');
    if (!gridLayout) return;
    var gridElementHeight = (_gridLayout$ = gridLayout[0]) === null || _gridLayout$ === void 0 ? void 0 : _gridLayout$.clientHeight;
    var newPlaceholderRows = Math.floor(gridElementHeight / layoutGridProps.rowHeight);
    newPlaceholderRows = newPlaceholderRows < minimumPlaceholderRowsCount ? minimumPlaceholderRowsCount : newPlaceholderRows;
    setPlaceholderRows(newPlaceholderRows);
    setplaceholderRowsArray(Array.from({
      length: newPlaceholderRows
    }).fill(null));
  }

  return React__default.createElement("div", {
    className: "dl-full-hight"
  }, React__default.createElement("div", {
    className: "dl-box"
  }, React__default.createElement("div", {
    className: "dl-row dl-content"
  }, React__default.createElement("div", {
    className: "dl-grid-container"
  }, React__default.createElement("div", {
    className: "dl-grid dl-grid--bordered"
  }, placeholderRowsArray.map(function (e, i) {
    return array12.map(function (e, i) {
      return React__default.createElement("div", {
        key: i,
        style: {
          height: layoutGridProps.rowHeight
        }
      });
    });
  })), React__default.createElement(ResponsiveReactGridLayout, Object.assign({}, layoutGridProps, {
    layouts: layouts,
    compactType: "vertical",
    onWidthChange: function onWidthChange() {
      return UpdatePlaceholderDimensions();
    },
    onLayoutChange: function onLayoutChange(layout, layouts) {
      return _onLayoutChange(layout, layouts);
    }
  }), layouts["lg"].map(function (el) {
    return React__default.createElement("div", {
      key: el.i
    }, React__default.createElement(WidgetCard, {
      key: el.i,
      widget: FindWidget(el),
      el: el,
      dateFilter: dateFilter,
      editBtnClicked: editWidget,
      deleteBtnClicked: deletePanel
    }));
  }))))));
};

var layoutGridProps = {
  rowHeight: 50,
  className: "layout",
  cols: {
    lg: 12,
    md: 6,
    sm: 2,
    xs: 1,
    xxs: 1
  },
  useCSSTransforms: true
};

var ApiServices = /*#__PURE__*/function () {
  function ApiServices() {
    this._apiUrl = Tools.GetLogitudeURL();
  }

  var _proto = ApiServices.prototype;

  _proto.getByFilters = function getByFilters(api, filters) {
    var token = this.getTokenFromStorage();
    var apiURL = "" + this._apiUrl + api;
    apiURL = this.ConcatFiltersToURL(filters, apiURL);
    return axios.get(apiURL, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.get = function get(api) {
    var token = this.getTokenFromStorage();
    var apiURL = "" + this._apiUrl + api;
    return axios.get(apiURL, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.post = function post(api, date) {
    var token = this.getTokenFromStorage();
    var apiURL = "" + this._apiUrl + api;
    return axios.post(apiURL, date, {
      headers: {
        'Content-Type': 'application/json',
        'Token': token
      }
    });
  };

  _proto.getTokenFromStorage = function getTokenFromStorage() {
    return window.localStorage.getItem("token") || '';
  };

  _proto.ConcatFiltersToURL = function ConcatFiltersToURL(filters, urlparameters) {
    var mykeys = Object.keys(filters);
    var addtionalFiltersValues = null;

    for (var i in mykeys) {
      var propName = mykeys[i];
      var propValue = filters[propName];
      var ignoreFilter = propName.indexOf("Operator") > 0 && propValue == "Equals" || propName == "AdditionalFilters";

      if (urlparameters != "?") {
        urlparameters = urlparameters.concat('&');
      }

      if (!ignoreFilter) {
        propValue = propValue ? encodeURIComponent(propValue) : '';
        urlparameters = urlparameters.concat(propName.concat('=').concat(propValue));
      }

      if (propName == "AdditionalFilters" && propValue.length > 0) {
        addtionalFiltersValues = JSON.stringify(propValue);
      }
    }

    if (addtionalFiltersValues) {
      urlparameters = urlparameters.concat("&AdditionalFilters=").concat(addtionalFiltersValues);
    }

    return urlparameters;
  };

  return ApiServices;
}();

var DashBoardService = /*#__PURE__*/function () {
  function DashBoardService() {
    this.tableName = 'DashBoard';
    this._ApiServices = new ApiServices();
  }

  var _proto = DashBoardService.prototype;

  _proto.getDataByFilters = function getDataByFilters(filters) {
    return this._ApiServices.getByFilters("/api/" + this.tableName + "Views/getbyfilters?", filters);
  };

  _proto.add = function add(data) {
    return this._ApiServices.post("/api/DashBoards", data);
  };

  return DashBoardService;
}();

var WidgetTypeListService = /*#__PURE__*/function () {
  function WidgetTypeListService() {
    this._ApiServices = new ApiServices();
  }

  var _proto = WidgetTypeListService.prototype;

  _proto.getDataByFilters = function getDataByFilters(filters) {
    return this._ApiServices.getByFilters("/api/WidgetTypeViews/getbyfilters?", filters);
  };

  _proto.getAll = function getAll() {
    return this._ApiServices.get("/api/WidgetTypeViews/getall");
  };

  return WidgetTypeListService;
}();

var Dashboard = function Dashboard(props) {
  var _props$token;

  var _useState = React.useState([]),
      dashbords = _useState[0],
      setDashbords = _useState[1];

  var _useState2 = React.useState(undefined),
      currentDashbord = _useState2[0],
      setCurrentDashbord = _useState2[1];

  var _useState3 = React.useState(),
      selectedWidget = _useState3[0];

  var _useState4 = React.useState(false),
      isInEditMode = _useState4[0],
      setIsInEditMode = _useState4[1];

  var _useState5 = React.useState(),
      WidgetTypes = _useState5[0],
      setWidgetTypes = _useState5[1];

  var dashboardMoreButtonToggle = React.createRef();
  var dashboardService = new DashBoardService();
  var widgetTypeListService = new WidgetTypeListService();
  React.useEffect(function () {
    getDashboards();
    getWidgetTypes();
    props.dataBinding.onGetDashboard.subscribe(function (e) {
      setCurrentDashbord(e);
    });
    props.dataBinding.onGetAllDashboard.subscribe(function (e) {
      setDashbords(e);
    });
  }, []);
  if ((props === null || props === void 0 ? void 0 : (_props$token = props.token) === null || _props$token === void 0 ? void 0 : _props$token.length) > 0) localStorage.setItem("token", props === null || props === void 0 ? void 0 : props.token);

  var getDashboards = function getDashboards() {
    dashboardService.getDataByFilters(new ApiQueryFilters()).then(function (data) {
      setDashbords(data.data.Result);
      if (data.data.Result.length > 0) setCurrentDashbord(data.data.Result[0]);
    });
  };

  var getWidgetTypes = function getWidgetTypes() {
    widgetTypeListService.getAll().then(function (data) {
      setWidgetTypes(data.data);
    });
  };

  var EditDashBoard = function EditDashBoard() {
    var _dashboardMoreButtonT;

    props.openAddEditDashboard(currentDashbord);
    dashboardMoreButtonToggle === null || dashboardMoreButtonToggle === void 0 ? void 0 : (_dashboardMoreButtonT = dashboardMoreButtonToggle.current) === null || _dashboardMoreButtonT === void 0 ? void 0 : _dashboardMoreButtonT.hide();
  };

  var addWidget = function addWidget(widgetCode) {
    props.openAddEditWidget({
      TypeCode: widgetCode
    });
  };

  var editDesign = function editDesign() {
    var _dashboardMoreButtonT2;

    setIsInEditMode(true);
    dashboardMoreButtonToggle === null || dashboardMoreButtonToggle === void 0 ? void 0 : (_dashboardMoreButtonT2 = dashboardMoreButtonToggle.current) === null || _dashboardMoreButtonT2 === void 0 ? void 0 : _dashboardMoreButtonT2.hide();
    console.log(WidgetTypes);
  };

  return React.createElement("div", {
    className: 'dl-full-hight'
  }, React.createElement("div", {
    className: 'dl-dashboard-header dl-card'
  }, React.createElement("div", {
    className: 'dl-flex-row'
  }, React.createElement("div", {
    className: 'dl-title-1'
  }, currentDashbord === null || currentDashbord === void 0 ? void 0 : currentDashbord.Name), React.createElement(button.Button, {
    icon: "pi pi-ellipsis-v",
    onClick: function onClick(e) {
      var _dashboardMoreButtonT3;

      return dashboardMoreButtonToggle === null || dashboardMoreButtonToggle === void 0 ? void 0 : (_dashboardMoreButtonT3 = dashboardMoreButtonToggle.current) === null || _dashboardMoreButtonT3 === void 0 ? void 0 : _dashboardMoreButtonT3.toggle(e);
    },
    className: "p-button-lg p-button-rounded p-button-text"
  }, React.createElement(ripple.Ripple, null)), React.createElement(overlaypanel.OverlayPanel, {
    ref: dashboardMoreButtonToggle,
    className: "buttons-overlay"
  }, React.createElement("div", {
    className: "buttons-list"
  }, React.createElement("div", {
    onClick: function onClick() {
      return EditDashBoard();
    }
  }, "Edit"), React.createElement("div", {
    onClick: editDesign
  }, "Edit Design")))), React.createElement("div", {
    className: 'dl-flex-row'
  }, !isInEditMode ? React.createElement("div", {
    className: 'dl-flex-row'
  }, React.createElement("div", {
    style: {
      width: "210px"
    }
  }, React.createElement(dropdown.Dropdown, {
    value: [],
    options: dashbords,
    optionValue: "Id",
    optionLabel: "Name",
    onChange: function onChange(e) {},
    placeholder: "Choose Dashboard",
    optionDisabled: function optionDisabled(option) {
      return option === null || option === void 0 ? void 0 : option.Disabled;
    },
    scrollHeight: "300px"
  })), React.createElement(button.Button, {
    icon: "pi pi-plus",
    onClick: function onClick() {
      return props.openAddEditDashboard(undefined);
    },
    className: "dl-dashboard-add p-button-rounded p-button-success",
    "aria-label": "Search"
  })) : null, isInEditMode ? React.createElement("div", {
    className: 'dl-flex-row'
  }, React.createElement(button.Button, {
    label: "Cancel",
    className: "p-button-text",
    onClick: function onClick() {
      setIsInEditMode(false);
    }
  }), React.createElement(button.Button, {
    label: "Save",
    form: "frm",
    onClick: function onClick() {
      setIsInEditMode(false);
    },
    autoFocus: true
  }), React.createElement("div", {
    style: {
      width: '192px',
      marginLeft: '15px'
    }
  }, React.createElement(dropdown.Dropdown, {
    value: selectedWidget,
    options: WidgetTypes,
    optionValue: "Code",
    optionLabel: "Name",
    onChange: function onChange(e) {
      return addWidget(e.value);
    },
    placeholder: "Add Component",
    optionDisabled: function optionDisabled(option) {
      return option === null || option === void 0 ? void 0 : option.Disabled;
    },
    scrollHeight: "300px"
  }))) : null)), React.createElement("div", {
    className: 'dl-dashboard-body'
  }, React.createElement(DashboardDesigner, {
    openEditWidget: function openEditWidget(widget) {
      return props.openAddEditWidget(widget);
    }
  })));
};

module.exports = Dashboard;
//# sourceMappingURL=index.js.map
